// 日志列表配置信息
export const columns = [
  { type: 'index' },
  { prop: 'LogCategory', label: 'Category', minWidth: 50, sortable: 'custom', showOverflowTooltip: true },
  { prop: 'ApiPath', label: 'Api', minWidth: 100, sortable: 'custom', showOverflowTooltip: true },
  // { prop: 'Params', label: 'Params', minWidth: 150, showOverflowTooltip: false },
  // { prop: 'Result', label: 'Result', minWidth: 150, showOverflowTooltip: false },
  { prop: 'RequestTime', label: 'Request Time', minWidth: 100, sortable: 'custom', showOverflowTooltip: true },
  { prop: 'ElapsedMilliseconds', label: 'Elapsed Milliseconds', minWidth: 100, showOverflowTooltip: true },
  { prop: 'OptUserName', label: 'Operator', minWidth: 100, sortable: 'custom', showOverflowTooltip: true },
  { prop: 'ClientIP', label: 'Client IP', minWidth: 100, showOverflowTooltip: true },
  { prop: 'Status', label: 'Status', minWidth: 70, sortable: 'custom', showOverflowTooltip: true },
  { prop: 'Message', label: 'Message', minWidth: 70, showOverflowTooltip: true }
]
const Category = [
  { label: 'Reviewer', value: 'Reviewer' },
  { label: 'Trial', value: 'Trial' },
  { label: 'Enroll', value: 'Enroll' },
  { label: 'Workload', value: 'Workload' },
  { label: 'Common', value: 'Common' },
  { label: 'Institution', value: 'Institution' },
  { label: 'Financial', value: 'Financial' },
  { label: 'Management', value: 'Management' },
  { label: 'Image', value: 'Image' }
]
export const searchForm = [
  {
    type: 'Select',
    label: 'Category:',
    prop: 'LogCategory',
    width: '120px',
    placeholder: '',
    options: Category,
    props: { label: 'label', value: 'value' },
    change: scope => ''
  },
  {
    type: 'Input',
    label: 'Keyword:',
    prop: 'Keyword',
    width: '120px',
    placeholder: ''
  },
  {
    type: 'Custom',
    slot: 'beginTimeSlot',
    label: 'Begin Time:',
    prop: 'BeginTime'
  },
  {
    type: 'Custom',
    slot: 'endTimeSlot',
    label: 'End Time:',
    prop: 'EndTime'
  }
]
export const searchHandle = [
  { label: 'Reset', type: 'primary', emitKey: 'reset' },
  { label: 'Search', type: 'primary', emitKey: 'search' }
]
