// 用户列表配置信息
export const columns = [
  { type: 'index' },
  {
    prop: 'UserCode',
    label: 'S/N',
    width: 100,
    sortable: 'custom',
    showOverflowTooltip: true
  },
  {
    prop: 'UserName',
    label: 'User ID',
    minWidth: 100,
    sortable: 'custom',
    showOverflowTooltip: true
  },
  {
    prop: 'RealName',
    label: 'Name',
    minWidth: 120,
    sortable: 'custom',
    showOverflowTooltip: true
  },
  {
    prop: 'Sex',
    label: 'Gender',
    hidden: true,
    slot: 'genderSlot',
    minWidth: 100,
    sortable: 'custom',
    showOverflowTooltip: true
  },
  {
    prop: 'Phone',
    label: 'Phone',
    minWidth: 120,
    sortable: 'custom',
    showOverflowTooltip: true
  },
  {
    prop: 'EMail',
    label: 'EMail',
    minWidth: 150,
    sortable: 'custom',
    showOverflowTooltip: true
  },
  {
    prop: 'OrganizationName',
    label: 'Organization',
    minWidth: 130,
    showOverflowTooltip: true
  },
  {
    prop: 'UserType',
    label: 'User Type',
    minWidth: 100,
    sortable: 'custom',
    showOverflowTooltip: true
  },
  // {
  //   prop: 'RoleNameList',
  //   label: 'Roles',
  //   hidden: true,
  //   slot: 'roleSlot',
  //   minWidth: 250,
  //   showOverflowTooltip: true
  // },
  {
    prop: 'Status',
    label: 'Status',
    hidden: true,
    slot: 'statusSlot',
    minWidth: 100,
    sortable: 'custom',
    showOverflowTooltip: true },
  { type: 'operate',
    label: 'Action',
    minWidth: 200,
    operates: [
      { name: 'Edit', type: 'primary', emitKey: 'editCb' },
      { name: 'Delete', type: 'danger', emitKey: 'deleteCb' }
    ] }
]

// 用户列表查询表单配置信息
export const searchForm = [
  {
    type: 'Input',
    label: 'User ID:',
    prop: 'UserName',
    width: '120px',
    placeholder: ''
  },
  {
    type: 'Input',
    label: 'Phone:',
    prop: 'Phone',
    width: '120px',
    placeholder: ''
  },
  {
    type: 'Input',
    label: 'Organization:',
    prop: 'OrganizationName',
    width: '120px',
    placeholder: ''
  },
  {
    type: 'Select',
    label: 'Status:',
    prop: 'UserState',
    width: '100px',
    options: [
      { label: 'Enable', value: 1 },
      { label: 'Disable', value: 0 }
    ],
    props: { label: 'label', value: 'value' },
    change: scope => '',
    placeholder: ''
  },
  {
    type: 'Select',
    label: 'User Type:',
    prop: 'UserType',
    width: '160px',
    options: [], // 下拉选项
    props: { label: 'UserType', value: 'Id' }, // 下拉选项配置信息，必填
    placeholder: ''
  }
]
// 用户列表查询表单事件配置信息
export const searchHandle = [
  { label: 'Reset', type: 'primary', emitKey: 'reset' },
  { label: 'Search', type: 'primary', emitKey: 'search' }
]
