/** ** template list config data *****/
export const template_cols = [
  { type: 'index' },
  {
    prop: 'Name',
    label: 'Name',
    minWidth: 110,
    sortable: 'custom',
    showOverflowTooltip: true
  },
  {
    prop: 'Modality',
    label: 'Modality',
    minWidth: 100,
    sortable: 'custom',
    showOverflowTooltip: true
  },
  {
    prop: 'Description',
    label: 'Description',
    minWidth: 110,
    sortable: 'custom',
    showOverflowTooltip: true
  },
  { type: 'operate',
    label: 'Action',
    minWidth: 150,
    operates: [
      { name: 'Items', type: 'primary', emitKey: 'items' },
      { name: 'Edit', type: 'primary', emitKey: 'edit' },
      { name: 'Delete', type: 'danger', emitKey: 'delete' }
    ] }
]
export const template_form = [
  {
    type: 'Input',
    label: 'Name:',
    prop: 'Name',
    width: '120px',
    placeholder: ''
  }
]
export const template_handle = [
  { label: 'Reset', type: 'primary', emitKey: 'reset' },
  { label: 'Search', type: 'primary', emitKey: 'search' }
]
export const template_model = {
  visible: false,
  title: '',
  width: '600px',
  showClose: true
}

/** ** template settings config data *****/
export const setting_cols = [
  { type: 'index' },
  {
    prop: 'Name',
    label: 'Item',
    sortable: 'custom',
    showOverflowTooltip: true
  },
  {
    prop: 'ModalityList',
    label: 'Modality',
    hidden: true,
    slot: 'modalitySlot',
    showOverflowTooltip: true
  },
  {
    prop: 'Description',
    label: 'Description',
    showOverflowTooltip: true
  },
  { type: 'operate',
    label: 'Action',
    minWidth: 150,
    operates: [
      { name: 'Edit', type: 'primary', emitKey: 'edit' },
      { name: 'Delete', type: 'danger', emitKey: 'delete' }
    ] }
]
export const setting_form = [
  {
    type: 'Select2',
    label: 'Modality:',
    prop: 'ModalityId',
    width: '150px',
    options: {}, // 下拉选项
    placeholder: ''
  }
]
export const setting_handle = [
  { label: 'Reset', type: 'primary', emitKey: 'reset' },
  { label: 'Search', type: 'primary', emitKey: 'search' }
]
export const setting_model = {
  visible: false,
  title: '',
  width: '600px',
  showClose: true
}
